#include "summa.hh"
#include "tulo.hh"
#include "yksikot.hh"
#include "yksikko.hh"

extern void Dump(elemp res);

extern Yksikot           Yks;
extern Yksikkomuunnokset Ymu;

bool SummaDebug = false;
bool CombineDebug = false;

summa& summa::operator*= (elemp p)
{
    elemap nmap;
    for(elemap::iterator i = elems.begin(); i != elems.end(); ++i)
    {
        tulop tmp = new tulo;
        tmp->insert(p);
        tmp->insert(i->first);
        nmap[&*tmp] += i->second;
    }
    
    nmap[p] += lisays;
    lisays = 0;
    
    elems = nmap;
    return *this;
}

bool summa::operator== (const Elem &e) const
{
    if(type != e.type)return false;
    const summa &tmp = *(const summa *)&e;
    return lisays == tmp.lisays
        && elems == tmp.elems;
}
bool summa::operator< (const Elem &e) const
{
    if(type < e.type)return true;
    if(type > e.type)return false;
    const summa &tmp = *(const summa *)&e;
    
    if(lisays < tmp.lisays)return true;
    if(lisays > tmp.lisays)return false;
    
    unsigned b=tmp.size();
    
    if(size() < b)return true;
    if(size() > b)return false;
    
    elemap::const_iterator i, j;
    
    for(i=elems.begin(), j=tmp.elems.begin();
        i!=elems.end();
        ++i, ++j)
    {
        if(i->second < j->second)return true;
        if(i->second > j->second)return false;
        if(i->first < j->first)return true;
    }
    return false;
}

void summa::Yksmuu(class Yksikkomuunnokset &)
{
}

elemp summa::Expand()
{
    elemap::iterator i;
    if(SummaDebug)cout << "Summa::Expand()\n";
retry:
    if(SummaDebug) { cout << "Summa expanding: "; Dump(this); }
    for(i=elems.begin(); i!=elems.end(); ++i)
    {
        if(i->second == 0)
        {
            if(SummaDebug)cout << "Summa: Dropped something\n";
            elems.erase(i);
            goto retry;
        }
        if(i->first->type == '+')
        {
            summap j = (summa *)&*i->first;
            if(SummaDebug) { cout << "Summa: Combining self with "; Dump(&*j); }
            elems.erase(i);
            
            lisays += i->second * j->lisays;
            for(elemap::iterator k = j->elems.begin();
                                 k!= j->elems.end();
                                 ++k)
            {
                elems[k->first] += k->second * i->second;
            }
            /* Jumping out of this scope uninitializes j,
             * and causes the pointer to be deallocated.
             */
            goto retry;
        }
        if(i->first->type == '*')
        {
            /* Yksikkmuunnokset suoritetaan tlt ksin, sill kerrointa
             * voidaan joutua vaihtamaan. Kerroin on summa-elementiss.
             */
            
               tulop tt = (tulo *)&*i->first;
                
            for(;;)
            {
                tulo::elemap::iterator a;
            ImaginaryRedo:
                for(a=tt->elems.begin(); a!=tt->elems.end(); ++a)
                {
                	if(a->first->type=='')a->second = 1;
                    if(a->first->type=='i')
                    {
                        if(a->second >= 4)
                        {
                            a->second = fmodl(a->second, 4);
                        }
                        else if(i->second <= -4)
                        {
                            a->second = -fmodl(-a->second, 4);
                        }
                        if(a->second >= 2)
                        {
                            a->second += -2;
                            i->second.negate();
                        }
                        if(a->second <= -2)
                        {
                            a->second += 2;
                            i->second.negate();
                        }
                        if(a->second==0)
                        {
                            tt->elems.erase(a);
                            goto ImaginaryRedo;
                        }
                    }
                    // Jakolaskut on kiva muuttaa kertolaskuiksi.
                    if(a->first->type=='+' && a->second < 0)
                    {
                    	summap t = (summa *)&*a->first;
                    	if(!t->size())
                    	{
                    		i->second /= t->lisays;
                    		tt->elems.erase(a);
                    		goto ImaginaryRedo;
                    	}
                    	if(t->lisays == 0 && t->size() <= 1)
                    	{
                    		summa::elemap::iterator k;
                    		for(k=t->elems.begin(); k!=t->elems.end(); ++k)
                    		{
                    			i->second /= k->second;
                    			tt->insert(k->first, a->second);
                    			tt->elems.erase(a);
                    			goto ImaginaryRedo;
                    		}
                    	}
                    }
                }
                break;
            }
             
            for(;;)
            {
                Yksikkomuunnokset::const_iterator ymi, ybe;
                
                int befo = 0, besi = 0;
                
                if(CombineDebug) { cout << "Combining for "; Dump(&*tt); }
                
                for(ymi = Ymu.begin(); ymi != Ymu.end(); ++ymi)
                {
                    const tulop &t = ymi->first;
                    
                    tulo::elemap::iterator a, b;
                    
                    if(CombineDebug) { cout << "Analyzing "; Dump(&*t); }
                        
                    for(int multi=1; multi>=-1; multi-=2)
                    {
                        int totsize = 0;
                        int found   = 0;
                        
                        for(a = t->elems.begin(); a != t->elems.end(); ++a)
                        {
                            tulo::potype pot = a->second * multi;
                            int abspot = int(pot<0 ? -pot : pot);
                            totsize += abspot;
                            #if 0
                            if(a->first->type=='z'           /* Hz is ugly */
                            || a->first->type=='S')++abspot; /* So is S    */
                            #endif
                            
                            b = tt->elems.find(new yksikko(a->first->type));
                            if(b != tt->elems.end())
                            {
                                if(CombineDebug)cout << "- Found from src: want pot=" << pot << ", bsecond=" << b->second << endl;
                                if((pot > 0 && b->second > 0)
                                || (pot < 0 && b->second < 0))
                                {
                                    tulo::potype ab = b->second - pot;
                                    if(pot < 0)ab = -ab;
                                    if(CombineDebug)cout << "- Which is good, ab=" << ab << ", abspot=" << abspot << "!\n";
                                    if(ab > 0)
                                        found += abspot;
                                    else
                                        found += int(abspot + ab);
                                }
                            }
                        }
                        
                        if(CombineDebug)cout << "- sign=" << multi << ", totsize = " << totsize << ", found=" << found << endl;
                        
                        if(found > befo && (found > totsize/2))
                        {
                            if(CombineDebug)cout << "- -> new record\n";
                            befo = found;
                            besi = multi;
                            ybe = ymi;
                        }
                    }
                }
                if(befo)
                {
                    const tulop &t = ybe->first;
                    tulo::elemap::iterator a;
                    for(a = t->elems.begin(); a != t->elems.end(); ++a)
                    {
                        if(CombineDebug)cout << "'" << a->first->type << "' cumulating with " << -a->second << endl;
                        tt->elems[a->first] += -a->second * besi;
                    }
                    if(CombineDebug) { cout << "Done, result: "; Dump(&*tt); }

                    merknum newke = i->second;
                    if(besi==1)newke *= ybe->second;else newke /= ybe->second;
                    elemp newelem = i->first;
                    
                    if(CombineDebug) { cout << "Erasing "; Dump(i->first); }
                    
                    elems.erase(i);
                    
                    if(newke != 0)
                    {
                        newelem = newelem->Expand();
                        if(CombineDebug) { cout << "dih.. newke = " << (real)newke << ", newelem: "; Dump(newelem); }
                        elems[newelem] = newke;
                    }
                    else
                        if(CombineDebug)cout << "dah\n";
                        
                    goto retry;
                }
                if(CombineDebug)cout << "No change\n" << flush;
                break;
            }
            
            if(!tt->size())
            {
                lisays += i->second;
                elems.erase(i);
                goto retry;
            }
        }
    }
    // Do this not before Yksikkomuunnokset has been handled
    if(size() == 1 && lisays == 0)
    {
        elemap::iterator j = elems.begin();
        if(j->second == 1)
        {
            if(SummaDebug)cout << "Summa: Became child\n";
            return j->first->Expand();
        }
    }
    if(SummaDebug) { cout << "Summa almost done: "; Dump(this); }
    elemap nmap;
    for(i=elems.begin(); i!=elems.end(); ++i)
        nmap[i->first->Expand()] += i->second;
    if(elems != nmap)
    {
        elems = nmap;
        goto retry;
    }
    if(SummaDebug) { cout << "Summa done: "; Dump(this); }
    return new summa(*this);
}
